<template>
  <div>
    <div v-if="products.length > 0" class="results">
      <h1 class="heading">نتایج جست و جو "{{search}}"</h1>
      <ProductList :products="products" />
    </div>
    <div class="no-result" v-else>
      <EmptyBoxIcon class="no-result__icon" />
      <h2 class="no-result__heading">نتیجه ای یافت نشد!</h2>
    </div>
  </div>
</template>

<script>
import ProductList from "@/components/catalog/ProductList";
import EmptyBoxIcon from "@/assets/svgs/empty_box.svg";

export default {
  components: {
    ProductList,
    EmptyBoxIcon
  },
  async asyncData(context) {
    let products = [];
    await context.store.dispatch('shop/fetchSearchResult', encodeURIComponent(context.route.query.query)).then(response => {
      products = response.data.data;
    });
    return {
      products
    }
  },
  head() {
    return {
      title: "جست و جو"
    }
  },
  mounted() {
    this.$store.dispatch('settings/setBackRoute', '/shop');
  },
  beforeDestroy() {
    this.$store.dispatch('settings/setBackRoute', '');
  },
  computed: {
    query() {
      return this.$route.query.query;
    },
    search() {
      return this.$route.query.query;
    }
  },
  watch: {
    query() {
      this.$store.dispatch('shop/fetchSearchResult', this.query).then(response => {
        this.products = response.data.data;
      });
    }
  }
}
</script>

<style lang="stylus" scoped>
@import '~assets/styles/variables';

.heading
  font-size 3.6rem
  margin-bottom $lg
  color $white
  font-weight 200
  @media only screen and (max-width: 600px)
    font-size 3rem
    margin-bottom $md

.no-result
  width 100%
  display flex
  flex-direction column
  align-items center
  &__heading
    color $white
    font-size 2rem
    text-align center
    direction rtl
    font-weight 300
  &__icon
    fill $white
    width 10rem
    height 10rem
    opacity .3
    margin-bottom $sm

</style>